package com.ningdatech.pmapi.irs;

import com.alibaba.fastjson.JSON;
import com.google.common.collect.Maps;
import com.ningdatech.pmapi.common.util.CryptUtils;
import com.ningdatech.pmapi.common.util.HmacAuthUtil;
import com.ningdatech.pmapi.common.util.RefreshKeyUtil;
import org.junit.Test;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.web.client.RestTemplate;

import java.security.NoSuchAlgorithmException;
import java.util.Collection;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * @Classname IrsTest
 * @Description
 * @Date 2023/6/26 17:42
 * @Author PoffyZhang
 */
public class IrsTest {

    @Test
    public void test1(){
        String method = "GET";
        String url = "https://bcdsg.zj.gov.cn:8443/restapi/prod/IC33000020230427000001/irs-res-bill/report/pdfUrl?appCode=A330000100000202105005790";
        String appScret = "BCDSGS_4ab4235d26a9a357170a39f3a13fd68c";
        String appKey = "BCDSGA_d874c8e46b541eb4e8aac6510fd3351b";

        Map<String, String> header = HmacAuthUtil.generateHeader(url, method, appKey, appScret);
        //请求头
        HttpHeaders headers = new HttpHeaders();

        for(Map.Entry<String, String> entry : header.entrySet()){
            headers.add(entry.getKey(), entry.getValue());
        }
        //封装请求头
        HttpEntity<MultiValueMap<String, Object>> formEntity = new HttpEntity<MultiValueMap<String, Object>>(headers);

        RestTemplate restTemplate = new RestTemplate();
        ResponseEntity<String> forEntity = restTemplate.exchange(url, HttpMethod.GET,formEntity, String.class);

        System.out.println(JSON.toJSONString(forEntity));
    }

    @Test
    public void test2() throws NoSuchAlgorithmException {
        long timestamp = System.currentTimeMillis();
        String areaCode = "331121";
        String appKey = "A331101453557202109017383";
        String appScret = "496f0f2a19994f76b4fd9dae087366c7";

        String requestSecret = RefreshKeyUtil.getRequestSecret(appKey, appScret);
        String capCode = CryptUtils.MD5Encode(timestamp + areaCode);
        String capTime = String.valueOf(timestamp);
        String sign = CryptUtils.MD5Encode(appKey + requestSecret + timestamp);
        String url = "https://interface.zjzwfw.gov.cn/gateway/api/proxy/001003001029/dataSharing/94wbaL1I1Pbz0648.htm?requestTime=" + timestamp +
                "&sign=" + sign + "&appKey=" + appKey + "&capCode=" + capCode + "&capTime=" + capTime +
                "&baseProjSys=测试应用&areaCode=331121&baseProjName=nsl-丽水演示项目&baseProjId=331100230130112233001" +
                "&isEffective=1&baseProjSysCode=25083657";
        RestTemplate restTemplate = new RestTemplate();
        ResponseEntity<String> forEntity = restTemplate.getForEntity(url, String.class);

        System.out.println(JSON.toJSONString(forEntity));
    }

    @Test
    public void test3() throws NoSuchAlgorithmException {
        long timestamp = System.currentTimeMillis();
        String areaCode = "331121";
        System.out.println(CryptUtils.MD5Encode(timestamp + areaCode));
    }
}
